CREATE TABLE kim_user(
	'name' VARCHAR(255) NOT NULL PRIMARY KEY,
	'uidNumber' INT NOT NULL,
	'gidNumber' INT,
	'gecos' VARCHAR(255),
	'homedir' TEXT,
	'bash' TEXT,
	'krbprincipalName' TEXT,
	'createTimestamp' INTEGER,
	'modifyTimestamp' INTEGER,
	'cachedTimestamp' INTEGER,
	'passwordExpiration' INTEGER,
	'dataExpiration' INTEGER,
	'isPosix' INT,
	'isLocked' INT,
	'isEnable' INT,
	'failedLoginAttempts' INT,
	'uniqueID' TEXT,
	'memberof_groups' TEXT,
	'memberofindirect_group' TEXT,
	'memberof_hbacrule' TEXT,
	'memberof_sudorule' TEXT
);

ALTER TABLE 'kim_user' ADD COLUMN 'logintimeset' CHAR(20);

ALTER TABLE 'kim_user' ADD COLUMN 'accountExpiration' INTEGER;

ALTER TABLE 'kim_user' ADD COLUMN 'lastFailedTime' INTEGER;

ALTER TABLE 'kim_user' ADD COLUMN 'lastUnlockTime' INTEGER;

CREATE TABLE kim_group(
	'name' VARCHAR(255) NOT NULL PRIMARY KEY,
	'gidNumber' INT,
	'users' TEXT,
	'isPosix' INT,
	'createTimestamp' INTEGER,
	'modifyTimestamp' INTEGER,
	'cachedTimestamp' INTEGER,
	'uniqueID' TEXT,
	'memberof_groups' TEXT,
	'memberof_hbacrule' TEXT,
	'memberof_sudorule' TEXT
);

CREATE TABLE kim_host(
	'name' VARCHAR(255) NOT NULL PRIMARY KEY,
	'isEnrolled' INT,
	'isEnabled' INT,
	'createTimestamp' INTEGER,
	'modifyTimestamp' INTEGER,
	'cachedTimestamp' INTEGER,
	'uniqueID' TEXT,
	'memberof_hbacrule' TEXT
);

CREATE TABLE kim_hbac(
	'name' VARCHAR(255) NOT NULL PRIMARY KEY,
	'isEnabled' INT,
	'createTimestamp' INTEGER,
	'modifyTimestamp' INTEGER,
	'cachedTimestamp' INTEGER,
	'uniqueID' TEXT,
	'allow_users' TEXT,
	'allow_groups' TEXT,
	'allow_service' TEXT
);

CREATE TABLE kim_config(
        'section' VARCHAR(64),
        'key' VARCHAR,
        'value' VARCHAR
);

ALTER TABLE 'kim_user' ADD COLUMN 'pwdFailedCount' INTEGER;
ALTER TABLE 'kim_user' ADD COLUMN 'pwdFailedReset' INTEGER;
ALTER TABLE 'kim_user' ADD COLUMN 'pwdLockoutSec' INTEGER;

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('diskadm', '5001', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('pkgadm', '5002', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('pkginst', '5003', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('usbcreator', '5004', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('mountadm', '5005', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('sysdadm', '5007', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('pkexadm', '5008', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('timeadm', '5010', 1);
